/*---------------------------------------------------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | Multiphase Code Repository by HZDR
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.767
  ||  ||  //    ||  // || \\   | License: GPL-3.0-or-later
  ==  == ====== ====   ==  ==  |
-------------------------------------------------------------------------------
License
    This file is part of the Multiphase Code Repository by HZDR.

    Copyright (C) 2025 by Helmholtz-Zentrum Dresden-Rossendorf e.V. (HZDR),
    Website: https://hzdr.de

    Multiphase Code Repository by HZDR is based on the free software for
    computational fluid dynamics (CFD) from the OpenFOAM Foundation.
    Copyright (C) 2025 by OpenFOAM Foundation, Website: https://openfoam.org

    If you are interested in which files are original OpenFOAM Foundation
    files, which OpenFOAM Foundation files were modified, and which files were
    newly created, see FILES.md.

    Multiphase Code Repository by HZDR is free software: you can redistribute
    it and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Multiphase Code Repository by HZDR is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
    Public License for more details.

    You should have received a copy of the GNU General Public License along
    with the Multiphase Code Repository by HZDR. If not, see
    <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "addonFvcSpread.H"
#include "wallDist.H"
#include "fvc.H"

// * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * * //

Foam::tmp<Foam::volScalarField> Foam::fvc::integrateWallNormal
(
    const volScalarField& field,
    const volScalarField& alpha,
    const label nLayers,
    const word patchName,
    const scalar alphaDiff
)
{
    const fvMesh& mesh = field.mesh();
    const volScalarField& yWall = wallDist::New(mesh).y();
    const surfaceVectorField nWallf(fvc::interpolate(wallDist::New(mesh).n()));

    const labelUList& owner = mesh.owner();
    const labelUList& neighbour = mesh.neighbour();

    tmp<volScalarField> tFilmThickness // rename to integral
    (
        new volScalarField
        (
            IOobject("integral", mesh.time().name(), mesh),
            mesh,
            dimensionedScalar(dimLength, Zero)
        )
    );
    volScalarField& integral = tFilmThickness.ref();

    volScalarField deltaY
    (
        IOobject("deltaY", mesh.time().name(), mesh),
        mesh,
        dimensionedScalar(dimLength, Zero)
    );

    deltaY.primitiveFieldRef() =
        mesh.V()*2
       /(
            fvc::surfaceSum(mag(mesh.Sf() & nWallf))
          + dimensionedScalar(dimArea, small)
        );

    scalar yDiff = alphaDiff;
    if (alphaDiff == -1)
    {
        const scalar minDeltaY = gMin(deltaY.primitiveField());
        yDiff = minDeltaY;
    }

    const volScalarField alphaY(alpha*yWall);

    for (int i = 0; i < nLayers; i++)
    {
        const volScalarField integral0(integral);

        forAll(owner, facei)
        {
            const label own = owner[facei];
            const label nbr = neighbour[facei];

            if (mag(alphaY[own] - alphaY[nbr]) < yDiff)
            {
                continue;
            }

            if
            (
                (alphaY[nbr] < alphaY[own])
             && (yWall[nbr] < yWall[own])
             && (integral0[nbr] <= integral0[own])
            )
            {
                integral[nbr] =
                    integral0[own] + deltaY[own]*field[own];
            }
            else if
            (
                (alphaY[own] < alphaY[nbr])
             && (yWall[own] < yWall[nbr])
             && (integral0[own] <= integral0[nbr])
            )
            {
                integral[own] =
                    integral0[nbr] + deltaY[nbr]*field[nbr];
            }
        }
    }

    const label patchi = mesh.boundaryMesh().findIndex(patchName);
    const scalarField deltas = mag(mesh.boundary()[patchName].delta());

    if (patchi == -1)
    {
        FatalErrorInFunction
            << "No patch found with name: " << patchName
            << exit(FatalError);
    }

    const fvPatchField<scalar>& integralpf =
        integral.boundaryField()[patchi];

    integral.boundaryFieldRef()[patchi] =
        integralpf.patchInternalField()
      + 2*deltas*field.boundaryField()[patchi].patchInternalField();

    return tFilmThickness;
}


// ************************************************************************* //
